# Rank-Polymorphism for Shape-Guided Blocking

This repository contains sources for our paper on blocked
matrix multiplication that is guided by array shapes.
You can also find all the source files we used in the experiments,
some proofs that are too long to include in the paper and
runtime measurements that were used to produce graphs.


## Repository Structure

The main file for the paper is `paper.tex` which includes
section files: each section lives in a separate file.  Here
is the list of section files in order:

  1. `abstract.tex` contains sources for *Abstract*.
  2. `intro.tex` contains sources for *Introduction*.
  3. `background.tex` contains sources for *Background*.
  4. `model.lagda` is a literate Agda file that is a source
     of the section *Discovering Blocked Algorithms*
  5. `recursive_algorithm.tex` contains sources for
     *Shape Recursion in SaC*.
  6. `performance.tex` contains sources for *Runtime Evaluation*.
  7. `related.tex` contains sources for *Related Work*.
  8. `conclusion.tex` contains sources for *Conclusions*.


All Agda formalisation can be found in `model.lagda` and
`proof.agda`.  The latter contains the proof of `mmx≈mm` in
Section 4 that is easier to do when reshapes are defined
inductively.  We use Agda 2.6.3 with the Standard library
version 1.7.2.

All the sources that we used in our runtim experiments can
be found in `mm-kernel/`.  Please consult the `mm-kernel/Makefile`
to see the versions that are available.

Runtime measurements that are used to produce graphs in the
paper are located in `data/`.


